package gihyo.lucene.ch3;

/**
 * Copyright 2006 SEKIGUCHI, Koji
 * 
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  http://www.apache.org/licenses/LICENSE-2.0
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

import java.io.IOException;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.document.Document;

public class TestDocument extends AbstractTestIndexReader {

    public static void main( String[] args ) throws IOException {
	AbstractTestIndexReader atir = new TestDocument();
	atir.makeIndex();
	IndexReader reader = atir.getIndexReader();
	int maxDoc = reader.maxDoc();
	for( int i = 0; i < maxDoc; i++ ){
	    Document doc = reader.document( i );
	    System.out.println( Integer.toString( i ) + " : " +
				atir.getDocumentContent( doc ) );
	}
	reader.close();
    }
}
